;==============================================================================
    include \masm32\include\masm32rt.inc
    include winio32.inc
    includelib winio32.lib
;==============================================================================

SHOWESP MACRO
    mov eax, esp
    printf( "ESP: %Xh\n", eax )
ENDM

;==============================================================================

printf MACRO format:REQ, args:VARARG
    IFNB <args>
        invoke crt_printf, cfm$(format), args
    ELSE
        invoke crt_printf, cfm$(format)
    ENDIF
    EXITM <>
ENDM

;==============================================================================
    .data
        dwVal      dd         0
        physStruct PHYSSTRUCT <>
    .code
;==============================================================================
start:
;==============================================================================
    ;------------------------------------------------------------------------
    ; In my test of InstallWinIoDriver, even when RemoveWinIoDriver returned
    ; success, the driver was not removed and continued to load automatically
    ; when Windows was started, and because of this InitializeWinIo and the
    ; function calls that follow it would always fail. The simple solution
    ; was to call the WinIo Version 2 RemoveWinIoDriver function.
    ;------------------------------------------------------------------------
    ;invoke InstallWinIoDriver, chr$("WinIo32.sys"), 0
    ;printf( "InstallWinIoDriver: %Xh\n", eax )
    ;invoke RemoveWinIoDriver
    ;printf( "RemoveWinIoDriver: %Xh\n", eax )
    ;inkey "Press any key to exit..."
    ;exit

    SHOWESP

    invoke InitializeWinIo
    printf( "InitializeWinIo: %Xh\n", eax )

    invoke SetPortVal, 300h, 0, 1
    printf( "SetPortVal: %Xh\n", eax )
    invoke GetPortVal, 300h, ADDR dwVal, 1
    printf( "GetPortVal: %Xh\n", eax )
    printf( "dwVal: %Xh\n", dwVal )

    invoke GetPhysLong, 400h, ADDR dwVal
    printf( "GetPhysLong: %Xh\n", eax )
    printf( "dwVal: %Xh\n", dwVal )

    invoke SetPhysLong, 400h, dwVal
    printf( "SetPhysLong: %Xh\n", eax )

    mov DWORD PTR physStruct.pvPhysAddress, 0
    mov DWORD PTR physStruct.dwPhysMemSizeInBytes, 4096

    invoke MapPhysToLin, ADDR physStruct
    mov ebx, eax
    printf( "MapPhysToLin: %Xh\n", ebx )

    invoke UnmapPhysicalMemory, ADDR physStruct
    printf( "UnmapPhysicalMemory: %Xh\n", eax )

    invoke ShutdownWinIo

    SHOWESP

    inkey "Press any key to exit..."
    exit
;==============================================================================
end start

